
try:
	import psyco
	print 'Imported pscyo.'
except:	print 'Failed to import psyco.'

import csnd
print 'Imported csnd.'
import CsoundAC
print 'Imported CsoundAC.'
import thread
import threading
import time

##################################################################
class Process(threading._Timer):
    def __init__(self, *args, **kwargs):
        print 'Process: __init__'
        threading._Timer.__init__(self, *args, **kwargs)
        self.setDaemon(True)

    def run(self):
        print 'Process: run'
        if self.interval == 0:    # if interval == 0, means run once
            print self
            self.function(*self.args, **self.kwargs)           
            return   
        while True:
            self.finished.clear()
            self.finished.wait(self.interval)
            if not self.finished.isSet():
                print self
                self.function(*self.args, **self.kwargs)
            else:
                return
            self.finished.set()

##################################################################
class ProcessManager(object):

    ops = []

    def add_process(self, process, interval, args=[], kwargs={}):
        op = Process(interval, process, args, kwargs)
        self.ops.append(op)
        thread.start_new_thread(op.run, ())

    def stop(self):
        for op in self.ops:
            op.cancel()
        #self._event.set()


##################################################################
def playnote():
    print "playing note!"
    csound.InputMessage("i1 0 .5")
	#cs.InputMessage("i1 0 1 0.1 440")
	#csound.PerformKsmps()



##################################################################
    
#our process manager, handles periodic events	
procman = ProcessManager()

# Create an instance of Csound.
csound = csnd.Csound()
res = csound.Compile("pytest3.csd")
perf = csnd.CsoundPerformanceThread(csound)
perf.Play()

procman.add_process(playnote, 1)

time.sleep(5)

procman.stop()

perf.Stop()
perf.Join()
